
package de.ivu.elect.business.gebietsbaum.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.gebietsbaum.entity.Gebietsgruppierung;

@RequestScoped
@Named(GebietsgruppierungConversationSelect.COMPONENT_NAME)
public class GebietsgruppierungConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gebietsgruppierungConversationSelect";

  @Inject
  protected transient GebietsgruppierungExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(GebietsgruppierungConversationStore.class)
  protected transient GebietsgruppierungConversationStore conversationStore;

  public GebietsgruppierungConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public Gebietsgruppierung getEntity() {
    return getEntityInternal();
  }

  private Gebietsgruppierung getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Gebietsgruppierung entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.gebietsbaum.entity.GebietsgruppierungPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Gebietsgruppierung entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.gebietsbaum.entity.GebietsgruppierungPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.gebietsbaum.entity.GebietsgruppierungPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected Gebietsgruppierung attach(Gebietsgruppierung entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Gebietsgruppierung attach( de.ivu.elect.business.gebietsbaum.entity.GebietsgruppierungPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
